#include <iomanip>  // necessário para métodos setf() de cin e ostream's

class Matrix {
  int linhas, colunas;
  int **mat;

public:
  Matrix();
  Matrix(int lins, int cols);
  Matrix(int **newmat, int lins, int cols);
  int getElement(int i, int k) const;
  void entrada();
  void saida();

  Matrix operator +(const Matrix& mat2) const;
  Matrix operator -(const Matrix& mat2) const;
  Matrix operator *(const Matrix& mat2) const;
  Matrix operator *(int escalar) const;
};

Matrix::Matrix()
{
  linhas = 0;
  colunas = 0;
  mat = NULL;
}

Matrix::Matrix(int lins, int cols)
{
  int i, k;

  linhas = lins;
  colunas = cols;

  mat = new int* [linhas];

  for (i=0; i < linhas; i++) {
    mat[i] = new int[colunas];
    for (k=0; k < colunas; k++)
      mat[i][k] = 0;
  }
}

Matrix::Matrix(int **newmat, int lins, int cols)
{
  int i, k;

  linhas = lins;
  colunas = cols;

  mat = new int* [linhas];

  for (i=0; i < linhas; i++) {
    mat[i] = new int[colunas];
    for (k=0; k < colunas; k++)
      mat[i][k] = newmat[i][k];
  }
}

int Matrix::getElement(int i, int k) const
{
  return (mat[i][k]);
}


void Matrix::entrada ()
{
  int i, k;

  if (mat) {
    for (i=0; i < linhas; i++)
      delete [] mat[i];
    delete [] mat;
  }
 
  cin >> linhas >> colunas;
  // colunas = linhas;

  mat = new int* [linhas];

  for (i=0; i < linhas; i++) {
    mat[i] = new int[colunas];
    for (k=0; k < colunas; k++)
      mat[i][k] = 0;
  }

  for (i=0; i < linhas; i++)
    for (k=0; k < colunas; k++)
      cin >> mat[i][k];
}

void Matrix::saida ()
{
  int i, k;

  //    cout.setf(ios::showpoint|ios::fixed);
  //    cout.precision(2);

  for (i=0; i < linhas; i++) {
    for (k=0; k < colunas; k++)
      cout << setw(5) << mat[i][k] << "\t";
    cout << endl;
  }
}

Matrix Matrix::operator+ (const Matrix& mat_2) const
{
  int i, k;
  int **soma = new int* [linhas];

// ********************************************
// FALTA TESTAR SE mat.linhasxcolunas == mat_2.linhasxcolunas
// FAZER ISTO VIA EXCECAO
// ********************************************

  for (i=0; i < linhas; i++)
    soma[i] = new int [colunas];

  for (i=0; i < linhas; i++)
    for (k=0; k < colunas; k++)
      soma[i][k] = mat[i][k] + mat_2.mat[i][k];
  
  return (Matrix(soma, linhas, colunas));
}

Matrix Matrix::operator- (const Matrix& mat_2) const
{
  int i, k;
  int **soma = new int* [linhas];

// ********************************************
// FALTA TESTAR SE mat.linhasxcolunas == mat_2.linhasxcolunas
// FAZER ISTO VIA EXCECAO
// ********************************************

  for (i=0; i < linhas; i++)
    soma[i] = new int [colunas];

  for (i=0; i < linhas; i++)
    for (k=0; k < colunas; k++)
      soma[i][k] = mat[i][k] - mat_2.mat[i][k];
  
  return (Matrix(soma, linhas, colunas));
}


Matrix Matrix::operator* (int escalar) const
{
  int i, k;
  int **prod = new int* [linhas];

  for (i=0; i < linhas; i++)
    prod[i] = new int [colunas];

  for (i=0; i < linhas; i++)
    for (k=0; k < colunas; k++)
      prod[i][k] = escalar * mat[i][k];
  
  return (Matrix(prod, linhas, colunas));
}

Matrix Matrix::operator* (const Matrix& mat_2) const
{
  int i,j,p,q;
  int **prod = new int* [linhas];

// ********************************************
// FALTA TESTAR SE mat.colunas == mat_2.linhas
// FAZER ISTO VIA EXCECAO
// ********************************************

  for (i=0; i < linhas; i++) {
    prod[i] = new int [mat_2.colunas];
    for (j=0; j < mat_2.colunas; j++)
      prod[i][j] = 0;
  }

  for (i=0; i < linhas; i++)
    for (j=0; j < mat_2.colunas; j++) {
      for (p=0; p < colunas; p++)
	prod[i][j] += mat[i][p] * mat_2.mat[p][j];
    }
  
  return (Matrix(prod, linhas, mat_2.colunas));
}
